print("test")

test="1234567"
print(len(test))
print(len(test)//3)

print(5*"*")
print("eergbfdoehg".count("e"))



def get_segments_sequence_and_paths(gfa):
    file_gfa=open(gfa,'r')
    lines_gfa=file_gfa.readlines()
    file_gfa.close()
    seg_seq={}
    paths={}
    for line in lines_gfa:
        line=line.split()
        if (line[0]=="S"): # get the sequence of the segment
            seg_id='s'+line[1]
            seg_seq[seg_id]=line[2]

        if (line[0]=="W") & (line[1]!="_MINIGRAPH_"): # get the walk of the genome
            
            path=line[6].replace(">",";>")
            path=path.replace("<",";<").split(';')
            list_path=[]
            for segment in path:
                if segment[0:1]=='>':
                    list_path.append('+s'+segment[1:])
                elif segment[0:1]=='<':
                    list_path.append('-s'+segment[1:])
 
            paths[line[3]]=list_path
    return [paths,seg_seq]


def convert_strand(strand):
    match strand:
        case "+":
            return ">"
        case "-":
            return "<"
        case ">":
            return "+"
        case "<":
            return "-"
        case default:
            return ""

global segments_on_target_genome
segments_on_target_genome={}

def get_segments_positions_on_genome(pos_seg):
    bed=open(pos_seg,'r')
    lines=bed.readlines() # read line by line ?
    bed.close()
    for line in lines:
        line=line.split()
        [seg,chrom,start,stop,strand]=[line[3][1:],line[0],int(line[1])+1,int(line[2]),line[3][0:1]] # +1 in the start to convert the bed 0-based coordinate to a 1-based system
        segments_on_target_genome[seg]=[chrom,start,stop,strand]

def get_feature_path(paths,first_seg,last_seg,target_genome_name):
    # find the path in target genome
    first_strand=convert_strand(segments_on_target_genome[first_seg][3])
    first_seg_stranded=first_strand+first_seg
    last_strand=convert_strand(segments_on_target_genome[last_seg][3])
    last_seg_stranded=last_strand+last_seg
    index_first_seg=int(paths[target_genome_name].index(first_seg_stranded))
    index_last_seg=int(paths[target_genome_name].index(last_seg_stranded))
    first_index=min(index_first_seg,index_last_seg)
    last_index=max(index_last_seg,index_first_seg)
    list_segfeat_target_genome=paths[target_genome_name][first_index:last_index+1]
    list_segfeat_target_genome_corrected=[convert_strand(segment_stranded[0])+segment_stranded[1:] for segment_stranded in list_segfeat_target_genome]
    return list_segfeat_target_genome_corrected


from Graph_gff import load_intersect

intersect_path="intersect_segments-genes_chr10.bed"
load_intersect(intersect_path)



# read the gfa, get the walks.
# load intersect, print paths of n features on the target genome.
# time, change indexation, time.

